﻿// --------------------------------------------------------------------------------------
//
// Wuerfeln                                                       Ulrich Müller 09.02.09
//                                                                Aspire C# 2008 Express
// Bildung von Zufallszahlen im Bereich 1 - 6 und Anzeige über Lampen an O1 - O7
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace Wuerfeln {
  public partial class FishWindows : Form {
    FishFace ft = new FishFace();
    int[] Wuerfel = { 0x8, 0x41, 0x49, 0x63, 0x6B, 0x77 };
    Random rnd = new Random();

    private void Action() {
      float summe = 0;
      int anz = 0;
      int w;
      do {
        for (int i = 0; i < 10; i++) {
          lblWurf.Text = "-";
          ft.SetMotors
            (new int[] { 0x8, 0x41, 0x49, 0x63, 0x6B, 0x77 }[new Random().Next(1, 6)]);
          ft.Pause(222);
        }
        w = rnd.Next(1, 7);
        anz++;
        summe += w;
        lblWurf.Text = w.ToString();
        lblStatus.Text = 
          String.Format("Mittelwert : {0:0.00} / {1:0} Werte", summe / anz, anz);
        ft.SetMotors(Wuerfel[w - 1]);
        ft.Pause(2222);
      } while (!ft.Finish());
      lblWurf.Text = "0";
    }

    #region --- Programm-Kontrolle ---
    public FishWindows() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}